unit _Busy;

/////////////////////////////////////////////////////////////////////
//
// Hi-Track Version 2
// Copyright (c) 2000-2002 Dmitry Liman [2:461/79]
//
// http://hi-files.by.ru
// http://hi-files.narod.ru
//
/////////////////////////////////////////////////////////////////////

interface

function  SetBusyFlag( const FileName: String ) : Boolean;
procedure DropBusyFlag( const FileName: String );

{ =================================================================== }

implementation

uses
{$IFDEF VIRTUALPASCAL}
  VpSysLow,
{$ELSE}
  Windows,
{$ENDIF}
  SysUtils, MyLib;

const
  DEAD = 6 * 3600;	// 6 hours

{ --------------------------------------------------------- }
{ SetBusyFlag                                               }
{ --------------------------------------------------------- }

function SetBusyFlag( const FileName: String ) : Boolean;
var
  F: Integer;
  Age: Integer;
  Tmp: String;
begin
  Result := False;
  Age := FileAge( FileName );
  if Age >= 0 then
  begin
    Writeln( 'Busy flag detected' );
    Age := CurrentUnixTime - DateTimeToUnix( FileDateToDateTime(Age) );
    if Age > DEAD then
    begin
      Writeln( 'The flag is ', Age div 60, ' minutes old, trying to kill it...' );
      if not DeleteFile( FileName ) then
      begin
        Writeln( 'Unable to kill old busy flag "', FileName, '"' );
        Exit;
      end;
    end;
  end;
  Tmp := ChangeFileExt( FileName, '.$$$' );
  F := FileCreate( Tmp );
  if F < 0 then
  begin
    Writeln( 'Could not create temp busy flag "', Tmp, '"' );
    Exit;
  end;
  FileClose( F );
  for F := 0 to 30 do
  begin
    if RenameFile( Tmp, FileName ) then
    begin
      Result := True;
      Exit;
    end;
    Writeln( 'Waiting... ', F );
{$IFDEF VIRTUALPASCAL}
    SysCtrlSleep( 1000 );
{$ELSE}
    Sleep( 1000 );
{$ENDIF}
  end;
  Writeln( ^M^J'Timeout :(' );
  DeleteFile( Tmp );
end; { SetBusyFlag }

{ --------------------------------------------------------- }
{ DropBusyFlag                                              }
{ --------------------------------------------------------- }

procedure DropBusyFlag( const FileName: String );
begin
  if not DeleteFile( FileName ) then
    Writeln( 'Could not unlink busy flag "', FileName, '"' );
end; { DropBusyFlag }

end.

