unit DT;

/////////////////////////////////////////////////////////////////////
//
// Hi-Track Version 2
// Copyright (c) 2000-2002 Dmitry Liman [2:461/79]
//
// http://hi-files.by.ru
// http://hi-files.narod.ru
//
// ------------------------------------------------------------------
//
// This code based on "Santa Fox Mail System" sources
// Copyright (c) 1996 Anton the Deinow & SF-Team
//
/////////////////////////////////////////////////////////////////////

INTERFACE

type
 tDOW=(Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday);

const
 sDOW:array[tDOW] of string[9] = (
  'Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');

 MinTime = 0;           {= 00:00 }
 MaxTime = 1439;        {= 23:59 }
 BadTime = $FFFF;

 HrsInDay = 24;         {ᮢ  ⪠}
 MinInDay = 1440;       {  ⪠}
 MinInHour = 60;        {  }

 SecInMin = 60;         {ᥪ㭤  }

type
 tTime=word;

 tTimePeriod=record
  rtBegin,      {砫 }
  rtEnd: tTime;  { ⢨ p}
  rDOW: byte;   {p  ᫥  ⢨ p 
                 . 4   rDOW : day begin
                 . 4   rDOW : day end}
 end;

 TimeArray=record
  nTPer:byte;
  TPer:array[1..7] of tTimePeriod;
 end;

function Str2Time(s:string):tTime;
{-p  p  tTime}
function Str2timePeriod(s:string;
                        var TPer:tTimePeriod):boolean;
{- p  p}
function MatchTimePeriod(TPer:tTimePeriod):boolean;
{-室  ⥪. p    TPer}
function MatchTimeArray(var TA:TimeArray):boolean;
{-᪠ ᨢ p p TA.TPer  p頥:
  TRUE==⥪.p/ 室    p }
function Str2timeArray(s:string; var TA:TimeArray):boolean;
{-p p, p `,'  p S  TA}

function MatchTime( const S: String ) : Boolean;

IMPLEMENTATION

uses MyLib, SysUtils;

function Str2Time(s:string):tTime;
{-p  p  tTime}
var
 H,M:word;

begin
 Result:=BadTime;

 if (Pos(':',s) < 2) or (Length(s) < 4) then exit;

 try
   H := StrToInt( Copy( s, 1, Pred(Pos(':',s)) ));
   M := StrToInt( Copy( s, Succ(Pos(':',s)), 2 ));
 except
   Exit;
 end;

 if (H >23) or (M >59) then exit;

 Result := H * MinInHour + M;
end;

function Str2timePeriod(s:string;
                        var TPer:tTimePeriod):boolean;
{-pp㥬  p  pp timePeriod  p  time}
var
 s1:string;
 i:integer;
 b:byte;

begin
 FillChar(TPer,SizeOf(tTimePeriod),0);
 TPer.rDOW:=$60;

 if cmpi(s, 'cm') = 0 then with TPer do begin   {p㣫筮}
  rtBegin:=0;
  rtEnd:=MaxTime;
  Result:=true;
  exit;
 end;

 s1:=Copy(s,1,pred(Pos('-',s)));
 Delete(s,1,Pos('-',s));

 Result:=false;

 with TPer do begin
  if Pos('.',s) <>0 then begin
    Val(Copy(s1,1,1), b, i);
    if b >6 then exit;
    rDOW:=b;
    Val(Copy(s,1,1), b, i);
    if b >6 then exit;
    rDOW:=rDOW or (b shl 4);
  end;

  if Pos(':',s1) <>0 then
   rtBegin:=Str2Time(Copy(s1,succ(Pos('.',s1)), 5))
  else
   rtBegin:=Str2Time(Copy(s,succ(Pos('.',s)), 5));

  rtEnd:=Str2Time(Copy(s,succ(Pos('.',s)), 5));

  if rtEnd =BadTime then rtEnd:=MaxTime;
 end;

 Result:=true;
end;

function CurTime:tTime;
var
 H,M,w : SWORD;

begin
 DecodeTime( Now, H, M, W, W );
 Result := H * MinInHour + M;
end;

function MatchTimePeriod(TPer:tTimePeriod):boolean;
{-室  ⥪. p    TPer}
var
 w,DoW:word;
 cT:tTime;

function MatchDay:boolean;
{-ᥣ譨  室  p⮪  TPer?}
begin
 with TPer do

 { p p >  p p 6.00:00-3.22:10}
 if (rDOW and $F) >(rDOW shr 4) then
  if (DoW <=(rDOW shr 4)) or (DoW >=(rDOW and $F)) then Result:=true
  else Result:=false
 else
 { p p <=  p p}
  if ((rDOW and $F) <=DoW) and                  {⥪. >= .p __}
     ((rDOW shr 4) >=DoW) then Result:=true   {⥪. <= .p}
  else Result:=false;
end;

function MatchTime:boolean;
{-⥪饥 p 室  p⮪  TPer?}
begin
 with TPer do

 {᫨ p p p > p p p 21:00-03:00 }
 if rtBegin > rtEnd then
  if (cT <=rtEnd) or (cT >=rtBegin) then Result:=true
  else Result:=false
 else
  if (cT >=rtBegin) and (cT <=rtEnd) then Result:=true
  else Result:=false;
end;

begin
 {-砥    p}
 DoW := Pred(DayOfWeek( Now ));
 cT:=CurTime;           { ⥪饥 p   WORD ( )}

{ with TPer do
  if (rDOW shr 4) =0 then rDOW:=rDOW or $70;}

  Result:=MatchDay and MatchTime;
end;

function MatchTimeArray(var TA:TimeArray):boolean;
{-᪠ ᨢ p p TA.TPer  p頥:
  TRUE==⥪.p/ 室    p }
var
 i:byte;


begin
 Result:=false;
 if TA.nTPer =0 then exit;

 for i:=1 to TA.nTPer do
   if MatchTimePeriod(TA.TPer[i]) then begin
     Result:=true;
     exit;
   end;
end;

function Str2timeArray(s:string; var TA:TimeArray):boolean;
{-p p, p `,'  p S  TA}
var
 z:byte;

begin
 TA.nTPer:=0;
 Result:=false;

 if Length(s) <>0 then begin
  for z:=1 to WordCount(s,[',']) do with TA do begin
   if Str2TimePeriod(ExtractWord(z,s,[',']),TPer[succ(nTPer)]) then Inc(nTPer);

   if z =7 then begin
     Result:= TA.nTPer <>0;
     exit;
   end;
  end;

  Result:= TA.nTPer <>0;
 end;
end;

{ --------------------------------------------------------- }
{ MatchTime                                                 }
{ --------------------------------------------------------- }

function MatchTime( const S: String ) : Boolean;
var
  TA: TimeArray;
begin
  if Str2timeArray( S, TA ) then
    Result := MatchTimeArray( TA )
  else
    raise Exception.Create( 'Bad time period: "' + S + '"' );
end; { MatchTime }

end.
